from django.db import models

# Create your models here.

from django.contrib.auth.models import User

#custom user based on normal user
class LadderUser(User):
    photo = models.ImageField(null=True, blank=True)# optional picture
    elo = models.FloatField(default=1500)



#simple model for a team
class Team(models.Model):
    name = models.TextField() #could perhaps be a charfield
    description = models.TextField(default="")
    elo = models.FloatField(default=1500)

    created_at = models.DateField(auto_now_add=True) #I add these to nearly every model
    modified_at = models.DateField(auto_now=True) #It's just handy to know when something was created and modified

#to connect users to teams!
class TeamMembership(models.Model):
    user = models.OneToOneField(LadderUser, related_name='team_memberships')
    team = models.OneToOneField(Team, related_name='memberships')
    #in this model we could also have other info - perhaps a bool "isadmin" as a flag to check if the member can kick/invite other members

    created_at = models.DateField(auto_now_add=True)
    modified_at = models.DateField(auto_now=True)

#some decisions to make here, do we just want to record after a match? or create a model for an upcomin match, and fill in results when done?
class Match(models.Model):
    #teama = models.OneToOneField(Team, related_name='matches')
    #teamb = models.OneToOneField(Team, related_name='matches_alt')
    #cancalled two lines above, would be hard to query and list - may make sense if you always have a "challenger" or something
    #I am using another "connection" model below instead (MatchParticipation)
    #buut, this may be a good time to use a "many-x" connection - I generally prefer a "connection" model though, as extra data can be stored on the connection

    planned_date = models.DateField()#could perhaps be a datetimefield

    winner = models.OneToOneField(Team, related_name='won_matches', null=True, blank=True)
    #could also fill in a loser

    created_at = models.DateField(auto_now_add=True)
    modified_at = models.DateField(auto_now=True)

class MatchParticipation(models.Model):
    match = models.OneToOneField(Match, related_name='teams')
    team = models.OneToOneField(Team, related_name='matches')
    created_at = models.DateField(auto_now_add=True)
    modified_at = models.DateField(auto_now=True)
